<?php

class mcUUID_ControllerAdmin_Tools extends XFCP_mcUUID_ControllerAdmin_Tools
{
	protected function _getUUIDModel()
	{
		return $this->getModelFromCache('mcUUID_Model_UUID');
	}
	
	protected function _getUserModel()
	{
		return $this->getModelFromCache('XenForo_Model_User');
	}
	
	public function actionUUID()
	{
		return $this->responseView('', 'mcUUID_uuid_regenerate');
	}
	
	public function actionUUIDsRegenerate()
	{
		$this->_assertPostOnly();
		
		$users = $this->_getUserModel()->getAllUsers();

		$names = array();
		
		foreach ($users as $user)
		{
			$names[] = strtolower($user['username']);
		}
		
		$uuids = $this->_getUUIDModel()->getUUIDsByNames($names);
		
		$uuidAssoc = array();
		
		foreach ($uuids as $uuid)
		{
			$uuidAssoc[strtolower($uuid['name'])] = $uuid['id'];
		}

		foreach ($users as $user)
		{
			if (isset($uuidAssoc[strtolower($user['username'])])) {
				$dw = XenForo_DataWriter::create('XenForo_DataWriter_User');
				$dw->setExistingData($user['user_id']);
				$dw->set('uuid', $uuidAssoc[strtolower($user['username'])]);
				$dw->save();
			}

		}
		
		return $this->responseMessage(new XenForo_Phrase('mcUUID_regeneration_complete'));
	}
}