<?php

class mcUUID_ControllerPublic_Account extends XFCP_mcUUID_ControllerPublic_Account
{
	protected function _getUUIDModel()
	{
		return XenForo_Model::create('mcUUID_Model_UUID');
	}
	
	protected function _getUserModel()
	{
		return XenForo_Model::create('XenForo_Model_User');
	}
	
	/*public function actionChangeUsername()
	{
		return $this->_getWrapper(
			'account', 'changeusername',
			$this->responseView('', 'mcUUID_change_username')
		);
	}*/
	
	public function actionChangeUsername() {
		$this->_assertRegistrationRequired();
		$user = XenForo_Visitor::getInstance();
		$uuid = $user->get('uuid');
		if (!$uuid) {
			return $this->responseError(new XenForo_Phrase('mcUUID_it_is_not_possible_to_change_username_no_uuid_set'));
		}
		
		$uname = false;
		$data = XenForo_Application::getSimpleCacheData('mcUUID_uuid');
		if ($data) {
			if (isset($data[$user['uuid']])) {
				$v = $data[$user['uuid']];
				if (time() - $v['time'] < 120) {
					$uname = $v['username'];
				}
			}
		} else {
			$data = array();
		}
		if (!$uname) {
			$uname = $this->_getUUIDModel()->getNameByUUID($user['uuid']);
			if ($uname) {
				$data[$user['uuid']] = array('time' => time(), 'username' => $uname);
				XenForo_Application::setSimpleCacheData('mcUUID_uuid', $data);
			}
		}
		
		if (!$uname || $uname === $user->get('username')) {
			return $this->responseError(new XenForo_Phrase('mcUUID_your_username_has_not_changed'));
		}
		
		$dw = XenForo_DataWriter::create('XenForo_DataWriter_User');
		$dw->setExistingData($user->get('user_id'));
		$dw->set('username', $uname);
		$dw->save();
		return $this->responseMessage(new XenForo_Phrase('mcUUID_username_changed_succesfully'));
	}
	
}