<?php

class mcUUID_DataWriter_User extends XFCP_mcUUID_DataWriter_User
{
	
	protected function _getUUIDModel()
	{
		return $this->getModelFromCache('mcUUID_Model_UUID');
	}
	
	protected function _getFields()
	{
		$array = parent::_getFields();
		
		$array['xf_user']['uuid'] = array('type' => self::TYPE_STRING, 'default' => '');
	
		return $array;
	}
	
	protected function _preSave()
	{
		parent::_preSave();
		
		if ($this->isInsert())
		{
			$uuid = $this->_getUUIDModel()->getUUIDByName($this->get('username'));
			if ($uuid) {
				$this->set('uuid', $uuid['id']);
			}
		}
		
	}
	
	protected function _verifyUsername(&$username) {
		$result = parent::_verifyUsername($username);
		if ($result == false) {
			foreach ($this->_errors as $key => $error) {
				if ($error instanceof XenForo_Phrase) {
					if ($error->getPhraseName() === 'usernames_must_be_unique') {
						$existingUser = $this->_getUserModel()->getUserByName($username);
						if ($existingUser && $existingUser['user_id'] != $this->get('user_id')) {
							$uuid = $this->_getUUIDModel()->getUUIDByName($existingUser['username']);
							$uuid = $uuid['id'];
							if ($uuid && $existingUser['uuid'] && $existingUser['uuid'] != $uuid) {
								$dw = XenForo_DataWriter::create('XenForo_DataWriter_User');
								$dw->setImportMode(true);
								$dw->setExistingData($existingUser['user_id']);
								
								$uname = false;
								$data = XenForo_Application::getSimpleCacheData('mcUUID_uuid');
								if ($data) {
									if (isset($data[$existingUser['uuid']])) {
										$v = $data[$existingUser['uuid']];
										if (time() - $v['time'] < 120) {
											$uname = $v['username'];
										}
									}
								} else {
									$data = array();
								}
								if (!$uname) {
									$uname = $this->_getUUIDModel()->getNameByUUID($existingUser['uuid']);
									if ($uname) {
										$data[$existingUser['uuid']] = array('time' => time(), 'username' => $uname);
										XenForo_Application::setSimpleCacheData('mcUUID_uuid', $data);
									}
								}
								
								if ($uname) {
									$dw->set('username', $uname);
									$dw->save();
									unset($this->_errors[$key]);
									return true;
								}
							}
						}
					}
				}
			}
		}
		return $result;
	}
	
}