<?php

class mcUUID_Model_UUID extends XenForo_Model
{
	protected static $url = "https://api.mojang.com/profiles/minecraft";
	protected static $profiles = 100;
	
	protected function _post($dataPaged) {
		$data = json_encode($dataPaged);
		
		$options = array(
			'http' => array(
				'header' => 'Content-Type: application/json',
				'method' => 'POST',
				'content' => $data
			)
		);
		
		$context = stream_context_create($options);
		$results = json_decode(file_get_contents($this::$url, false, $context), true);
		
		return $results;
	}
	
	public function getUUIDsByNames($names)
	{
		if (!$names) {
			return false;
		}
		
		$count = count($names);
		$pages = ceil($count / $this::$profiles);
		$final = array();
		
		for ($page = 0; $page < $pages; $page ++) {
			$index = ($page *  $this::$profiles);
			$fetchNames = array_slice($names, $index, $this::$profiles);

			$data = $this->_post($fetchNames);
			$final = array_merge($final, $data);
		}
		return $final;
	
	}
	
	public function getUUIDByName($name)
	{
		if (!$name) {
			return false;
		}
		
		$dataRaw = array($name);

		$data = json_encode($dataRaw);
		
		$options = array(
				'http' => array(
						'header' => 'Content-Type: application/json',
						'method' => 'POST',
						'content' => $data
				)
		);
		
		$context = stream_context_create($options);
		$results = json_decode(file_get_contents($this::$url, false, $context), true);
		
		if (!isset($results[0]['id']))
		{
			return false;
		}
		
		return $results[0];
	}
	
	public function getNameByUUID($uuid) {
		if (!$uuid) {
			return false;
		}
		$result = json_decode(file_get_contents('https://sessionserver.mojang.com/session/minecraft/profile/' . $uuid), true);
		if (!isset($result['name'])) {
			return false;
		}
		return $result['name'];
	}
	
	public function setUUIDForUser($user)
	{
		$uuid = $this->getUUIDByName($user['username']);
		
		$dw = XenForo_DataWriter::create('XenForo_DataWriter_User');
		
		$dw->setExistingData($user['user_id']);
		
		$dw->set('uuid', $uuid['id']);
		
		$dw->save();
	}
	
}